"use strict";

{
	C3.Plugins.Lagged_API.Acts =
	{
		ShowAd(urlkey,thumbnail)
		{
			console.log('LaggedAPI: show an ad');
			if(LaggedAPI&&!this._adPlaying){
				var self=this;

				self.Trigger(C3.Plugins.Lagged_API.Cnds.PauseGame);
				self._adPlaying=true;

				if(this._adcnt<45&&!this._offlineMode){
					// console.log('Lagged API: Ad played too soon, timer needs to be above 45: ', this._adcnt);
					// console.log(urlkey);
					// console.log(thumbnail);
					self.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
					self._adPlaying=false;
					return true;
				}

				try{
				LaggedAPI['APIAds'].show('interstitial',urlkey,thumbnail,function(response) {
					self._adcnt=-45;
				  if(response.success) {
				    console.log('ad done');
				  }else {
				    console.log(response.errormsg);
				  }
					self._adPlaying=false;
					self.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
				});
				}catch(e){
					self.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
					self._adPlaying=false;
				}
			}
		},
		ShowAwards()
		{
			try{
			LaggedAPI['Achievements'].show();
			}catch(e){
			console.log('test mode: open achievement');
			}
		},
		InitGame(gameid)
		{
			try{
				LaggedAPI.init(gameid,'lagdevaF3001');
				if(this._offlineMode){
				console.log('LaggedAPI: init game with id ', gameid)
				}
			}catch(e){
				console.log(e);
			}
		},
		SaveAchievement(award)
		{
			try{
			if(this._savedAchs.indexOf(award) > -1){

				console.log('LaggedAPI: achievement already saved, skip ', award);

			}else{
			var ach_numb=[];
			ach_numb.push(award);
			this._savedAchs.push(award);
			LaggedAPI['Achievements'].save(ach_numb, function(response) {
			if(response.success) {
			console.log('achievement saved')
			// note that we could still have a failure errorcode here when the player
			// already has an achievement
			}else {
			console.log(response.errormsg);
			}
			});

			if(this._offlineMode){
				console.log('LaggedAPI: save achievement ', award);
			}
			}
			}catch(e){
				console.log(e);
			}
		},
		SaveScore(score,board)
		{

			try{
			var boardinfo={};
			boardinfo['score']=score;
			boardinfo['board']=board;
			LaggedAPI['Scores'].save(boardinfo, function(response) {
			if(response.success) {
			console.log('high score saved')
			}else {
			console.log(response.errormsg);
			}
			});
			}catch(e){
				console.log(e);
			}

			if(this._offlineMode){
			console.log('LaggedAPI: Save high score: ', score);
			console.log('LaggedAPI: Save to board id: ', board)
			}

		},
		ViewWalkthrough(jwid)
		{
			console.log("api play walkthrough jwid: ", jwid)
			try{
			window.parent.viewPlaythrough(jwid);
			}catch(e){
				try{
			    var postmsg='walkthrough|'+jwid;
					console.log('post msg: ', postmsg);
					window.parent.postMessage(postmsg,'*');
				}catch(e){
					console.log(e);
				}
			console.log(e);
			}

		}
	};
}
